/*----------------------------------------------------
   MISC.C -- Telnet Client, Terminal Emulator Program
             ̑낢
   Copyright (c) 2002-2003
        Hiroto Shigeta. All rights reserved.
  ----------------------------------------------------*/
#include <windows.h>

/* ̋󔒂菜Ԃ */
void GetAfterSpaceCutString(const char *pszSrc, UINT cchLen, char *pszDst, UINT cchSize)
{
	UINT i;
	int  iSpaceStartPos = -1;

	memset(pszDst, 0, cchSize);
	for (i = 0; i < cchLen; i++) {
		if (IsDBCSLeadByte(pszSrc[i])) {
			iSpaceStartPos = -1;
			i++;
		} else {
			if (pszSrc[i] == ' ') {
				if (iSpaceStartPos == -1) {
					iSpaceStartPos = (int)i;
				}
			} else {
				iSpaceStartPos = -1;
			}
		}
	}
	if (iSpaceStartPos == -1) {// ɋ󔒂͂Ȃ
		strncpy(pszDst, pszSrc, min(cchLen, cchSize - 1));
	} else if (iSpaceStartPos != 0) {
		strncpy(pszDst, pszSrc, min((UINT)iSpaceStartPos, cchSize - 1));
	}
}

/* Ï(n_()-I_(E))RECT\̂ɃZbg */
void SetSelArea(int xSelFrom, int ySelFrom, int xSelTo, int ySelTo, RECT *prc)
{
	if (ySelFrom == ySelTo) {
		prc->top = prc->bottom = ySelFrom;
		if (xSelFrom < xSelTo) {
			prc->left  = xSelFrom;
			prc->right = xSelTo;
		} else {
			prc->left  = xSelTo;
			prc->right = xSelFrom;
		}
	} else if (ySelFrom < ySelTo) {
		prc->top    = ySelFrom;
		prc->left   = xSelFrom;
		prc->bottom = ySelTo;
		prc->right  = xSelTo;
	} else {
		prc->top    = ySelTo;
		prc->left   = xSelTo;
		prc->bottom = ySelFrom;
		prc->right  = xSelFrom;
	}
}

/* 2Byte2Byteڂ? */
BOOL IsDBCSSecondByte(const char *pstrString, int iIndex)
{
	int i = 0;

	while (i < iIndex) {
		IsDBCSLeadByte(pstrString[i]) ? i = i + 2 : i++;
	}
	return i != iIndex;
}

/* pporA_[XRA('_')̔ */
BOOL IsAlphaNum_(char ch)
{
	if ((ch >= '0' && ch <= '9') ||
		(ch >= 'A' && ch <= 'Z') ||
		(ch >= 'a' && ch <= 'z') ||
		ch == '_') {
		return TRUE;
	}
	return FALSE;
}

/* 2Byte̕R[hrbOGfBA */
#define MOJICODE(ch) MAKEWORD(ch[1], ch[0])

#define TYPE_ALPHANUM1 1	/* pp   */
#define TYPE_KATAKANA1 2	/* pJ^Ji */
#define TYPE_HIRAGANA  3	/* Ђ炪     */
#define TYPE_KATAKANA2 4	/* SpJ^Ji */
#define TYPE_KANJI     5	/*          */
#define TYPE_ALPHANUM2 6	/* Spp   */

/* Iʒu(iPos)̒P̊JnʒuƏIʒuԂ */
int GetWordPos(const char *pszLine, int iPos, int *piWordFrom, int *piWordTo)
{
	char *pNextChar;
	WORD wKanji;
	int  iWordType = 0;
	int  i         = 0;
	int  iStartPos = 0;
	WORD wCode     = 0;

	pNextChar = (char *)pszLine;
	while (*pNextChar != '\0') {
		if (IsDBCSLeadByte(*pNextChar)) {
			wKanji = MOJICODE(pNextChar);
			if (wKanji >= MOJICODE("") && wKanji <= MOJICODE("")) {
				// Ђ炪
				if (iWordType != TYPE_HIRAGANA) {
					if (i > iPos) {
						break;
					} else {
						iStartPos = i;
						iWordType = TYPE_HIRAGANA;
					}
				}
			} else if ((wKanji >= MOJICODE("@") && wKanji <= MOJICODE("")) ||
					   wKanji == MOJICODE("[")) {
				// SpJ^Ji
				if (iWordType != TYPE_KATAKANA2) {
					if (i > iPos) {
						break;
					} else {
						iStartPos = i;
						iWordType = TYPE_KATAKANA2;
					}
				}
			} else if ((wKanji >= MOJICODE("R") && wKanji <= MOJICODE("Z")) ||
					   (wKanji >= MOJICODE("") && wKanji <= MOJICODE("")) ||
					   (wKanji >= MOJICODE("@") && wKanji <= MOJICODE("")) ||
					   (wKanji >= MOJICODE("\") && wKanji <= MOJICODE("K"))) {
				// 
				if (iWordType != TYPE_KANJI) {
					if (i > iPos) {
						break;
					} else {
						iStartPos = i;
						iWordType = TYPE_KANJI;
					}
				}
			} else if ((wKanji >= MOJICODE("O") && wKanji <= MOJICODE("")) ||
					   wKanji == MOJICODE("Q")) {
				// Spp
				if (iWordType != TYPE_ALPHANUM2) {
					if (i > iPos) {
						break;
					} else {
						iStartPos = i;
						iWordType = TYPE_ALPHANUM2;
					}
				}
			} else {
				// ̑̑Sp
				if (iWordType != 0 || wCode != *((WORD *)pNextChar)) {
					if (i > iPos) {
						break;
					} else {
						iStartPos = i;
						iWordType = 0;
						wCode     = *((WORD *)pNextChar);
					}
				}
			}
			pNextChar += 2;
			i += 2;
		} else {
			if (IsAlphaNum_(*pNextChar)) {
				// pp
				if (iWordType != TYPE_ALPHANUM1) {
					if (i > iPos) {
						break;
					} else {
						iStartPos = i;
						iWordType = TYPE_ALPHANUM1;
					}
				}
			} else if ((*pNextChar >= '' && *pNextChar <= '') ||
					   (*pNextChar >= '' && *pNextChar <= '')) {
				// pJ^Ji
				if (iWordType != TYPE_KATAKANA1) {
					if (i > iPos) {
						break;
					} else {
						iStartPos = i;
						iWordType = TYPE_KATAKANA1;
					}
				}
			} else {
				// ̑̔p
				if (iWordType != 0 || wCode != (WORD)*pNextChar) {
					if (i > iPos) {
						break;
					} else {
						iStartPos = i;
						iWordType = 0;
						wCode     = (WORD)*pNextChar;
					}
				}
			}
			pNextChar++;
			i++;
		}
	}
	*piWordFrom = iStartPos;
	*piWordTo   = i;
	return iWordType;
}

/* TCYƕԊul̎擾 */
int GetFontCharSize(HWND hwnd, HFONT hFont, int *pcxChar, int *pcyChar)
{
	HDC        hdc;
	HFONT      hOldFont;
	TEXTMETRIC tm;
	int        iSpace;

	// ̑傫̎擾
	hdc = GetDC(hwnd);
	hOldFont = SelectObject(hdc, hFont);
	GetTextMetrics(hdc, &tm);
	*pcxChar = tm.tmAveCharWidth;
	*pcyChar = tm.tmHeight;
	// Ԃ̋󔒂̒lvZ
	if (tm.tmCharSet == SHIFTJIS_CHARSET) {
		SIZE size1, size2;

		GetTextExtentPoint32(hdc, "a",  1, &size1);
		GetTextExtentPoint32(hdc, "", 2, &size2);
		iSpace = size1.cx * 2 - size2.cx;
	} else {
		iSpace = 0;
	}
	SelectObject(hdc, hOldFont);
	ReleaseDC(hwnd, hdc);
	return iSpace;
}
