/*--------------------------------------------------------
   TERMINAL.C -- Telnet Client, Terminal Emulator Program
             [
   Copyright (c) 2002-2005
        Hiroto Shigeta. All rights reserved.
  --------------------------------------------------------*/
#include <windows.h>

/* Functions in VT52.C */
int  VT52Control(char c);
BOOL VT52KeyDown(WPARAM wParam, LPARAM lParam);
BOOL TextOutVT52(HDC hdc, int nXStart, int nYStart, LPCTSTR lpString, int cbString,
				 HFONT hFont, int cxChar, BOOL bSelected, char *cchAttr);
void ChangeFontVT52(HWND hwnd, HFONT hFont);

/* Functions in VT100.C */
int  VT100Control(char c);
BOOL VT100KeyDown(WPARAM wParam, LPARAM lParam);
BOOL TextOutVT100(HDC hdc, int nXStart, int nYStart, LPCTSTR lpString, int cbString,
				  HFONT hFont, int cxChar, BOOL bSelected, char *cchAttr);
void ChangeFontVT100(HWND hwnd, HFONT hFont);

/* ^[~i^Cv */
char szTerminalType[32] = "vt100";

/* [R[h */
int TerminalControl(char c)
{
	switch (szTerminalType[2]) {
	case '5':
		return VT52Control(c);
	default:
		return VT100Control(c);
	}
}

/* L[M */
BOOL VTKeyDown(WPARAM wParam, LPARAM lParam)
{
	switch (szTerminalType[2]) {
	case '5':
		return VT52KeyDown(wParam, lParam);
	default:
		return VT100KeyDown(wParam, lParam);
	}
}

/* eLXgʏo */
BOOL TextOutVT(HDC hdc, int nXStart, int nYStart, LPCTSTR lpString, int cbString,
			   HFONT hFont, int cxChar, BOOL bSelected, char *pchAttr)
{
	return TextOutVT100(hdc, nXStart, nYStart, lpString, cbString,
						hFont, cxChar, bSelected, pchAttr);
}

/* tHgύX */
void ChangeFontVT(HWND hwnd, HFONT hFont)
{
	ChangeFontVT100(hwnd, hFont);
}
