/*----------------------------------------------------
   VT52.C -- Telnet Client, Terminal Emulator Program
             vt52[
   Copyright (c) 2002-2005
        Hiroto Shigeta. All rights reserved.
  ----------------------------------------------------*/
#include <windows.h>
#include "monitor.h"
#include "socket.h"
#include "mycolor.h"

/* Variables in CODESET.C */
extern BOOL bJisKanji;

/* Variables in TELNET.C */
extern char cRecvState;
extern char cCtrlState[32];

/* [R[h */
int VT52Control(char c)
{
	if (cCtrlState[0] == 0) {
		switch (c) {
		case 'J':
			/* Lbg肠Ƃ̕\NA */
			DebugRcvPrint("[J]\n");
			ClearMonAfterCaret();
			cRecvState = 0;
			break;
		case 'K':
			/* Lbg̈ʒus̏I܂łNA */
			DebugRcvPrint("[K]\n");
			ClearLineAfterCaret();
			cRecvState = 0;
			break;
		case 'H':
			DebugRcvPrint("[H]");
			MoveCaret(0, 0);/* [ESC][H]̂[ESC][J]҂Ȃ(HP-UXΉ) */
			cRecvState = 0;
			break;
		case 'Y':
			DebugRcvPrint("[Y]");
			cCtrlState[0] = c;
			break;
		case 'A':
			/* Lbgֈړ */
			DebugRcvPrint("[A]\n");
			MoveCaretUpOne();
			cRecvState = 0;
			break;
		case 'B':
			/* Lbgֈړ */
			DebugRcvPrint("[B]\n");
			MoveCaretDownOne();
			cRecvState = 0;
			break;
		case 'C':
			/* LbgEֈړ */
			DebugRcvPrint("[C]\n");
			MoveCaretRightOne();
			cRecvState = 0;
			break;
		case 'D':
			/* Lbgֈړ */
			DebugRcvPrint("[D]\n");
			MoveCaretLeftOne();
			cRecvState = 0;
			break;
		case 'I':
			/* ʂ1sփXN[ */
			DebugRcvPrint("[I]\n");
			ScrollUpMon();
			cRecvState = 0;
			break;
		case '$':
			DebugRcvPrint("[$]");
			cCtrlState[0] = c;
			break;
		case '(':
			DebugRcvPrint("[(]");
			cCtrlState[0] = c;
			break;
		default:
			DebugRcvPrint("[%03d]\n", (c & 0xFF));
			cRecvState = 0;
			break;
		}
	} else if (cCtrlState[0] == 'Y') {
		if (cCtrlState[1] == 0) {
			DebugRcvPrint("[%03d]", ((c - ' ') & 0xFF));
			cCtrlState[1] = c;
		} else {
			/* LbgWwňړ */
			DebugRcvPrint("[%03d]\n", ((c - ' ') & 0xFF));
			MoveCaret(((c - ' ') & 0xFF), ((cCtrlState[1] - ' ') & 0xFF));
			cRecvState = 0;
		}
	} else if (cCtrlState[0] == '$') {
		/* JISin */
		DebugRcvPrint("[%c]", c);/* @ or B */
		bJisKanji = TRUE;
		cRecvState = 0;
	} else if (cCtrlState[0] == '(') {
		/* JISout */
		DebugRcvPrint("[%c]", c);/* B or J */
		bJisKanji = FALSE;
		cRecvState = 0;
	} else {/* Ô */
		DebugRcvPrint("[%03d]\n", (c & 0xFF));
		cRecvState = 0;
	}
	return 0;
}

/* L[M */
BOOL VT52KeyDown(WPARAM wParam, LPARAM lParam)
{
	switch (wParam) {
	case VK_UP:
		SendToServerOne('\x1B');
		SendToServerOne('A');
		return TRUE;
	case VK_DOWN:
		SendToServerOne('\x1B');
		SendToServerOne('B');
		return TRUE;
	case VK_RIGHT:
		SendToServerOne('\x1B');
		SendToServerOne('C');
		return TRUE;
	case VK_LEFT:
		SendToServerOne('\x1B');
		SendToServerOne('D');
		return TRUE;
	}
	return FALSE;
}

/* eLXgʏo */
BOOL TextOutVT52(HDC hdc, int nXStart, int nYStart, LPCTSTR lpString, int cbString,
				 HFONT hFont, int cxChar, BOOL bSelected, char *pchAttr)
{
	SetTextColor(hdc, GetMyColor(bSelected ? COLOR_HIGHLIGHTTEXT : COLOR_WINDOWTEXT));
	SetBkColor(hdc, GetMyColor(bSelected ? COLOR_HIGHLIGHT : COLOR_WINDOW));
	return AdjustTextOut(hdc, nXStart, nYStart, lpString, cbString, 0, 0);
}

/* tHgύX */
void ChangeFontVT52(HWND hwnd, HFONT hFont)
{
}
